"use strict";
{
    self.C3.Behaviors.skymenBoids.Acts = {
        Flock(targetX, targetY, flockTargetType, targetPriority, seperationPriority, alignmentPriority, cohesionPriority, seperationDistance)
{
    var deltax = targetX - this.inst.GetWorldInfo().GetX();
    var deltay = targetY - this.inst.GetWorldInfo().GetY();
    // Normalise
    var normalx = 0;
    var normaly = 0;
    var length = Math.sqrt(deltax * deltax + deltay * deltay);
    if (length > 0)
    {
        normalx = deltax / length;
        normaly = deltay / length;
    }
    // Head towards the target x,y at maximum allowed speed, adjusted for priorty
    var desiredVelocityX = normalx * this.maxSpeed * targetPriority;
    var desiredVelocityY = normaly * this.maxSpeed * targetPriority;
    // Group behaviours must be calculated by looping through and considering relationship
    // between this entity and every other member of the flock
    var flockers = flockTargetType.GetInstances();
    var count = flockers.length;
    for (var i = 0; i < count; i++)
    {
        var a = flockers[i];
        // Don't flock yourself!
        if (a == this.inst)
        {
            continue;
        }
        // Calculate distance to other flock member
        var deltax = this.inst.GetWorldInfo().GetX() - a.GetWorldInfo().GetX();
        var deltay = this.inst.GetWorldInfo().GetY() - a.GetWorldInfo().GetY();
        var distance = Math.sqrt(deltax * deltax + deltay * deltay);
        // Normalise
        var normalx = 0;
        var normaly = 0;
        if (distance > 0)
        {
            normalx = deltax / distance;
            normaly = deltay / distance;
        }
        // Do not flock with actors who are far away
        //if (distance > seperationDistance * 2)
        //  continue;
        // SEPERATION: steer to avoid crowding local flockmates (short range repulsion)
        var seperationX = 0;
        var seperationY = 0;
        if (distance == 0)
        {
            distance = 0.0000001;
        } // Prevent div/0!
        if (distance < seperationDistance)
        {
            // Calculate seperation force, adjusted for priority.
            seperationX = normalx / (distance / seperationDistance) * seperationPriority;
            seperationY = normaly / (distance / seperationDistance) * seperationPriority;
            // Add seperation to desired velocity
            desiredVelocityX = desiredVelocityX + seperationX;
            desiredVelocityY = desiredVelocityY + seperationY;
        }
        // COHESION: steer towards average position of neighbors (long range attraction)
        // Calculate cohseive force, adjusted for priority.
        var cohesionX = -normalx * cohesionPriority / count;
        var cohesionY = -normaly * cohesionPriority / count;
        // Add cohesion to desired velocity, adjusted for priority.
        desiredVelocityX = desiredVelocityX + cohesionX;
        desiredVelocityY = desiredVelocityY + cohesionY;
        // ALIGNMENT: steer towards average heading of neighbors
        // Calculate alignment force, adjusted for priority.
        
        let aBehavior = a._behaviorInstances.find(x=>{
        	return x._behavior instanceof self.C3.Behaviors.skymenBoids;
        })
        
        let angle = a.GetWorldInfo().GetAngle();
        if (aBehavior) angle = aBehavior._sdkInst.getAngle();
        
        var alignmentX = Math.cos(C3.toRadians(angle)) * alignmentPriority / count;
        var alignmentY = Math.sin(C3.toRadians(angle)) * alignmentPriority / count;
        // Add alignment to desired velocity, adjusted for priority.
        desiredVelocityX = desiredVelocityX + alignmentX;
        desiredVelocityY = desiredVelocityY + alignmentY;
    }
    // Calculate steering force as the difference between
    // desired velocity and actual current velocity
    var sx = desiredVelocityX - this.dx;
    var sy = desiredVelocityY - this.dy;
    // Calculate magnitude of steering force
    var force = Math.sqrt(sx * sx + sy * sy);
    // Truncate if greater than maxForce
    var scaleFactor = (force > this.maxForce) ? this.maxForce / force : 1;
    // Set the steering force
    this.sx = sx * scaleFactor;
    this.sy = sy * scaleFactor;
},

Setmaxspeed(speed)
{
	this.maxSpeed = speed;
},

Setmaxforce(force)
{
	this.maxForce = force;
},

SetAngle(setAngle)
{
	this.setAngle = setAngle;
}
    };
}